# filterdata.AWK  
# This file  ifilters out data for measurement ids that have full subgroups  
# C. McKenna 9/8/95  
#  
BEGIN{  
  
  
	# Fields are seperated by ~   
	FS="~"  
  
	# DEBUG printf toggle  
	DEBUG=0
  
}  
  
# Start of main processing  
  
{  
  
	if(NR == 1) {
		output_file = sprintf("%s",FILE)
 
#		remove destination files
        	rm_string = sprintf("rm -f %s", output_file)
 
        	system (rm_string)

		createtmp = sprintf("\n")
		print(createtmp) > output_file
	}
	
	if (DEBUG)  
	{  
		printf("\n processing record "  NR " \n")  
        }				  
  
   
	if ($0 == "")  
	{	  
		next	  
	}	  
  
	if (DEBUG)  
	{  
		printf ("The record is " $0 "\n")  
	}  
  
  
	# Get all fields and assign them to variables  
  
	char_no = $1  
	if (DEBUG)  
	{  
		printf("Characteristic number is " char_no"\n")  
	}  
  
	machine_no = $2  
	if (DEBUG)  
	{  
		printf("Machine number is " machine_no"\n")  
	}  
  
	measurement = $3  
	if (DEBUG)  
	{  
		printf("Measurement is " measurement"\n")  
	}  
  
	job_measurement_id = $4  
	if (DEBUG)  
	{  
		printf("Job Measurement ID is " job_measurement_id"\n")  
	}  
  
	subgroup_no = $5  
	if (DEBUG)  
	{  
		printf("Subgroup Number  is " subgroup_no"\n")  
	}  
  
	subgroup_index = $6  
	if (DEBUG)  
	{  
		printf("Subgroup Index  is " subgroup_index"\n")  
	}  
  
	subgroup_size = $7  
	if (DEBUG)  
	{  
		printf("Subgroup Size  is " subgroup_size"\n")  
	}  
  
	if (NR == 1)  
	{  
		cnt_subgroup_members	= 1
		curr_subgroup_index 	= subgroup_index 

		current_job_id = job_measurement_id
		current_subgroup_no = subgroup_no  
		total_subgroup_size = subgroup_size  
		count = 1  
		data[count] = $0  
		  
		# get next record  
		next  
	}	  
  
  
  
  
	# if data for same subgroup_number
	  
	if (( subgroup_no == current_subgroup_no) && (job_measurement_id == current_job_id))  
	{  
		if (DEBUG)  
			printf(" Have record with subgroup same as last record\n")  
  
		# save off current record  
		count = count + 1  
		data[count] = $0  

		if(curr_subgroup_index != subgroup_index)
		{
			cnt_subgroup_members = cnt_subgroup_members + 1
		}
		curr_subgroup_index 	= subgroup_index 
  
		#get next record  
		if (DEBUG)  
		{  
			printf("Current number of subgroup members is " cnt_subgroup_members "\n")
			printf("subgroup index is " subgroup_index "and count is " count "\n")  
			printf("total subgroup size is" total_subgroup_size "\n")  
			printf("Skipping to next record\n")  
		}  
		next  
	}  
	else  
	{  
	 	# a change in subgroup number  
		if (DEBUG)  
		{  
		        printf(" subgroup no changed from last record \n")  
		}  
			  
		# check the current subgroup size against count  
		# if they are equal, then there is a full subgroup  
  
		if ( cnt_subgroup_members == total_subgroup_size)  
  
		{  
			if (DEBUG)  
				printf("Count the the same as subgroup size, full subgroup \n")  
  
			# write out array of saved data to output file  
  
			if (DEBUG)  
			{  
				printf("total subgroup size is" total_subgroup_size "\n")  
			}  
  
	 		for (i=1; i <= count; i++)   
			{  
  
				if (DEBUG)  
				{  
					printf("data[" i "] is " data[i] "\n")  
				}  
  
  
				if (data[i] != "")  
					printf(data[i]" \n") >> output_file  
  
				data[i] = ""  
			}  
  
			if (DEBUG)  
			{  
				printf("end of writing subgroup data to file\n")  
			}  
		}   
  
		# reset counter to zero  
		count = 1  
  
		current_job_id = job_measurement_id
		current_subgroup_no = subgroup_no  
		total_subgroup_size = subgroup_size  
		  
		cnt_subgroup_members	= 1
		curr_subgroup_index 	= subgroup_index 

		data[count] = $0  

	}  
  
  
} #end of main processing  
  
END {  
  
	close(output_file)  
}  
   
 

